/* VisNow
   Copyright (C) 2006-2019 University of Warsaw, ICM
   Copyright (C) 2020 onward visnow.org
   All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.writers.NIfTIWriter;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.writers.NIfTIWriter.NIfTIWriterShared.*;
import org.visnow.vn.system.main.VisNow;
import org.visnow.vn.system.swing.filechooser.VNFileChooser;

/**
 * GUI for NIfTI writer.
 *
 * @author Piotr Wendykier (piotr.wendykier@gmail.com)
 */
public class GUI extends javax.swing.JPanel
{

    private static final long serialVersionUID = -1883452479819311533L;

    private String lastPath = null;
    private Parameters parameters;

    public GUI()
    {
        initComponents();
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p)
    {
        tfFileName.setText(p.get(FILENAME));
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        formatGroup = new javax.swing.ButtonGroup();
        fileChooser = new javax.swing.JFileChooser();
        selectButton = new javax.swing.JButton();
        tfFileName = new javax.swing.JTextField();
        writeButton = new javax.swing.JButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0));

        setMinimumSize(new java.awt.Dimension(180, 122));
        setOpaque(false);
        setPreferredSize(new java.awt.Dimension(200, 200));
        setLayout(new java.awt.GridBagLayout());

        selectButton.setText("select file"); // NOI18N
        selectButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                selectButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(selectButton, gridBagConstraints);

        tfFileName.setMinimumSize(new java.awt.Dimension(4, 22));
        tfFileName.setPreferredSize(new java.awt.Dimension(78, 22));
        tfFileName.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                tfFileNameActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(tfFileName, gridBagConstraints);

        writeButton.setText("write"); // NOI18N
        writeButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                writeButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(writeButton, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void tfFileNameActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_tfFileNameActionPerformed
    {//GEN-HEADEREND:event_tfFileNameActionPerformed
        parameters.setParameterActive(false);
        parameters.set(FILENAME, tfFileName.getText());
        parameters.setParameterActive(true);
    }//GEN-LAST:event_tfFileNameActionPerformed

    private void writeButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_writeButtonActionPerformed
    {//GEN-HEADEREND:event_writeButtonActionPerformed
        String path = parameters.get(FILENAME);
        if (path != null) {
            parameters.setParameterActive(false);
            parameters.setParameterActive(true);
            parameters.set(WRITE, !parameters.get(WRITE));
        }
    }//GEN-LAST:event_writeButtonActionPerformed

    private void selectButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_selectButtonActionPerformed
    {//GEN-HEADEREND:event_selectButtonActionPerformed
        if (lastPath == null) {
            fileChooser.setCurrentDirectory(new File(VisNow.get().getMainConfig().getUsableDataPath(NIfTIWriter.class)));
        } else {
            fileChooser.setCurrentDirectory(new File(lastPath));
        }
        FileNameExtensionFilter fieldFilter = new FileNameExtensionFilter("NIfTI files", "nii.gz", "nii");
        fileChooser.setFileFilter(fieldFilter);
        String path;
        int returnVal = fileChooser.showDialog(this, "Select");
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            path = VNFileChooser.filenameWithExtenstionAddedIfNecessary(fileChooser.getSelectedFile(), fieldFilter);
            tfFileName.setText(path);
            lastPath = path.substring(0, path.lastIndexOf(File.separator));
            VisNow.get().getMainConfig().setLastDataPath(lastPath, NIfTIWriter.class);
            parameters.setParameterActive(false);
            parameters.set(FILENAME, path);
            parameters.setParameterActive(true);
        }
    }//GEN-LAST:event_selectButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JFileChooser fileChooser;
    private javax.swing.Box.Filler filler1;
    private javax.swing.ButtonGroup formatGroup;
    private javax.swing.JButton selectButton;
    private javax.swing.JTextField tfFileName;
    private javax.swing.JButton writeButton;
    // End of variables declaration//GEN-END:variables
}
